require("nvim-goodies.string")
local g = require("nvim-goodies")
local os = require("nvim-goodies.os")
local path = require("plenary.path")
local scan = require("plenary.scandir")

local M = {}

M.directory_sep = g.iff(os.is_windows, "\\", "/")
M.not_directory_sep = g.iff(os.is_windows, "/", "\\")

function M.create_path(...)
  local ret =
    path:new({...}):absolute():gsub(M.not_directory_sep, M.directory_sep):gsub(
    M.directory_sep .. M.directory_sep,
    M.directory_sep
  )

  return ret
end

function M.get_file_name_list(dir, remove_extension, extension_no_dot)
  extension_no_dot = (extension_no_dot or "lua"):lower()
  local list = {}

  local files = scan.scan_dir(dir, {hidden = true, depth = 1})
  for _, name in ipairs(files) do
    local file_name = path:new(name):make_relative(dir):lower()
    if file_name:ends_with("." .. extension_no_dot) then
      table.insert(list, g.iff(remove_extension, file_name:sub(1, -5), file_name))
    end
  end
  return list
end

return M
